/* @(#)ed.c.c	1.1 revision of 90/06/2  00:37:52
 *
 * Copyright (c) 1990, Jens-Uwe Mager, Helios Software GmbH
 * Not derived from licensed software.
 *
 * Permission is granted to freely use, copy, modify, and redistribute
 * this software, provided that no attempt is made to gain profit from it,
 * the author is not construed to be liable for any results of using the
 * software, alterations are clearly marked as such, and this notice is
 * not modified.
 */

#include <stdio.h>
#include <string.h>

main(argc, argv)
int argc;
char **argv;
{
	char *sh, *p, *getenv();
	char *argp;
	int arglen;
	char *malloc();

	setuid(0);
	setgid(0);
	if (!(sh = getenv("SHELL")))
		sh = "/bin/sh";
	if (p = strrchr(sh, '/'))
		p++;
	else
		p = sh;
	if (argc > 1) {
		register char **tmp, *tmp1;
		arglen = 0;
		for (tmp = argv+1; *tmp; tmp++)
			arglen += strlen(*tmp);
		if (!(argp = malloc(arglen+1))) {
			perror("malloc");
			exit(1);
		}
		for (tmp = argv+1, tmp1 = argp; *tmp; tmp++) {
			strcpy(tmp1, *tmp);
			tmp1 += strlen(tmp1);
			*tmp1++ = ' ';
		}
		*--tmp1= '\0';
		execl(sh, p, "-c", argp);
	} else
		execl(sh, p, NULL);
	perror(sh);
	exit(1);
}
